<template>
  <b-container>
    <h2>SE CONNECTER</h2>
    <b-form 
      v-if="show"
      @submit="onSubmit"
      @reset="onReset"
    >
      <b-form-group
        id="input-group-1"
        label-for="input-1"
      >
        <b-form-input
          id="input-1"
          v-model="form.email"
          placeholder="Adresse mail"
          required
        />
      </b-form-group>

      <b-form-group
        id="input-group-2"
        label-for="input-2"
      >
        <b-form-input
          id="input-2"
          v-model="form.password"
          type="password"
          placeholder="Mot de passe"
          required
        />
      </b-form-group>
      <b-button
        type="submit"
        variant="primary"
      >
        Se connecter
      </b-button>
    </b-form>
    <router-link to="/inscription">
      Vous n'avez pas encore de compte ?
    </router-link>
  </b-container>
</template>

<script>
// import Test from '../components/Test.vue'
import { useStore } from '@/store/store';
import * as jose from 'jose';



  export default {
    // components: {
    //   Test,
    // },
    data() {

      const store = useStore();

      return {
        form: {
          email: '',
          password: ''
        },
        show: true
      }
    },
    methods: {
      onSubmit(event) {
        const url = process.env.VUE_APP_URL;
        event.preventDefault();
        
        fetch(url +"/connexion", {
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(this.form),
            method: 'POST'
        })
        .then(res => res.json())
        .then(json => {
            if (json.code != 401){
              const store = useStore();
              store.login(json.token);
              localStorage.setItem('token', json.token);
              store.fetchUser();
              // const payload = jose.decodeJwt(json.token);
              // const id = payload.id;
              // localStorage.setItem('user', id);
              this.$router.push('/');
            }
        })
        .catch(err => console.log(err))
      },
      onReset(event) {
        event.preventDefault()
        // Reset our form values
        this.form.email = ''
        this.form.password = ''
        // Trick to reset/clear native browser form validation state
        this.show = false
        this.$nextTick(() => {
          this.show = true
        })
      }
    }
  }
</script>